<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
    <head>
        <title>Lookup/Ibis web service client API</title>
    </head>
    <body>
        <p>
            This document describes the Lookup/Ibis web service client API, which
            is intended to simplify the task of using the web service from Java
            client applications.
        </p>

        <p>
            This client library provides code to automatically handle the
            following tasks:
        </p>
        <ul>
            <li style="list-style-type:disc;">
                Securely connect to the server over HTTPS, checking its certificates
                to ensure that it is really is the Lookup/Ibis server.
            </li>
            <li style="list-style-type:disc;">
                Authenticate with the server using HTTP Basic Authentication.
            </li>
            <li style="list-style-type:disc;">
                Construct correct URLs to methods on the server, encoding any method
                parameters that may form part of the path, or appear in the query
                string.
            </li>
            <li style="list-style-type:disc;">
                Encode any form parameters that may be needed in the request body.
            </li>
            <li style="list-style-type:disc;">
                Parse the XML returned by the server, producing one or more linked
                Java objects containing all the requested information in an easily
                accessible form.
            </li>
        </ul>

        <p>
            All of the API methods are contained in <code>XxxMethods</code>
            classes in the <a href="uk/ac/cam/ucs/ibis/methods/package-summary.html">
            uk.ac.cam.ucs.ibis.methods</a> package, for example
            <a href="uk/ac/cam/ucs/ibis/methods/PersonMethods.html">PersonMethods</a>
            which contains methods relating to or returning people, and
            <a href="uk/ac/cam/ucs/ibis/methods/InstitutionMethods.html">InstitutionMethods</a>
            which contains methods relating to or returning institutions. All
            the <code>XxxMethods</code> classes are auto-generated, to keep
            them in sync with the matching server methods.
        </p>

        <p>
            Some typical code using this API might look something like this:
        </p>
        <pre>
    import uk.ac.cam.ucs.ibis.client.*;
    import uk.ac.cam.ucs.ibis.dto.*;
    import uk.ac.cam.ucs.ibis.methods.*;

    ClientConnection conn = IbisClientConnection.createTestConnection();
    InstitutionMethods im = new InstitutionMethods(conn);

    List&lt;IbisPerson&gt; people = im.getMembers("UIS", null);

    for (IbisPerson person : people)
        System.out.println(person.visibleName);
        </pre>

        <p>
            Note that it is typically only necessary to create a single instance
            of the <code>ClientConnection</code> and <code>XxxMethods</code>
            objects, and then re-use them throughout your Java application.
        </p>

        <h4>Thread safety</h4>

        <p>
            Once created and initialised, the <code>ClientConnection</code> and
            <code>XxxMethods</code> classes are safe to use from multiple
            simultaneous threads (for example in a web server).
        </p>

        <p>
            Note, however, that
            <a href="uk/ac/cam/ucs/ibis/client/ClientConnection.html#setUsername(java.lang.String)">
            ClientConnection.setUsername()</a> and
            <a href="uk/ac/cam/ucs/ibis/client/ClientConnection.html#setPassword(java.lang.String)">
            ClientConnection.setPassword()</a> are not thread safe. These methods
            are regarded as part of the initialisation of the connection, and
            should typically only be used once on startup. If you need to
            regularly switch between users, then use a separate
            <code>ClientConnection</code> per user or per thread (and separate
            corresponding <code>XxxMethods</code> objects).
        </p>
    </body>
</html>
